//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

bool isfakeservicesuser(const unsigned char* usr) {
	if (cuo.services_activated == 1) {
		if (strcasecmp(usr,"chanserv") == 0) {return true;}
		if (strcasecmp(usr,"nickserv") == 0) {return true;}
		if (strcasecmp(usr,"global") == 0) {return true;}
		if (strcasecmp(usr,"operserv") == 0) {return true;}
	}
	return false;
}
void writeservicesnick(unsigned char* usr) {
	if (strcasecmp(usr,"chanserv") == 0) {strcpy(usr,"ChanServ");}
	if (strcasecmp(usr,"nickserv") == 0) {strcpy(usr,"NickServ");}
	if (strcasecmp(usr,"global") == 0) {strcpy(usr,"Global");}
	if (strcasecmp(usr,"operserv") == 0) {strcpy(usr,"OperServ");}
}
unsigned char static_giveSVname_buffer[500];
unsigned char* giveSVname(const unsigned char* name) {
	strncpy(static_giveSVname_buffer,name,499);
	static_giveSVname_buffer[499] = 0;
	writeservicesnick(static_giveSVname_buffer);
	return static_giveSVname_buffer;
}
sqlite3 *nickdb;
sqlite3 *chandb;
bool services_db_init() {
	char *zErrMsg = 0;
	int dbp;
	printf("%s    > Opening the nick database...\n",startupprefixsub);
	dbp = sqlite3_open("nick.db", &nickdb);
	if (dbp) {
		printf("%s          -Failed to open ./nick.db!\n",startupprefixsub);
		return false;
	}
	printf("%s          -Database opened\n",startupprefixsub);
	dbp = sqlite3_exec(nickdb,"CREATE TABLE IF NOT EXISTS usertable ( useraccount_name TEXT, useraccount_password TEXT, useraccount_email TEXT, useraccount_registertime INTEGER, userid INTEGER PRIMARY KEY AUTOINCREMENT )",NULL,0,&zErrMsg);
	if (dbp!=SQLITE_OK) {
		sqlite3_free(zErrMsg);printf("%s          -Failed to insert default table\n",startupprefixsub);
		sqlite3_close(nickdb);
		return false;
	}
	zErrMsg = 0;
	printf("%s    > Opening the channel database...\n",startupprefixsub);
	dbp = sqlite3_open("chans.db", &chandb);
	if (dbp) {
		printf("%s          -Failed to open ./chans.db!\n",startupprefixsub);
		sqlite3_close(nickdb);
		return false;
	}
	printf("%s          -Database opened\n",startupprefixsub);
	dbp = sqlite3_exec(nickdb,"CREATE TABLE IF NOT EXISTS chantable ( chan_name TEXT, chan_origname TEXT, chan_owner TEXT, chan_topic TEXT, chan_modes TEXT, chan_registertime INTEGER, chan_welcomemsg TEXT, chan_oplvl3list TEXT, chan_oplvl2list TEXT, chan_oplvl1list TEXT, chan_halfoplist TEXT, chan_voicelist TEXT, chan_autovoice_activated INTEGER, chanid INTEGER PRIMARY KEY AUTOINCREMENT )",NULL,0,&zErrMsg);
	if (dbp!=SQLITE_OK) {
		sqlite3_free(zErrMsg);printf("%s          -Failed to insert default table\n",startupprefixsub);
		sqlite3_close(nickdb);
		sqlite3_close(chandb);
		return false;
	}
	return true;
}
bool chanregistered(const unsigned char* chan) {
	unsigned char lclchan[40];
	strncpy(lclchan,chan,39);lclchan[39] = 0;strlwr(lclchan);trimleft(lclchan);cutonfirstspace(lclchan);
	if (strlen(lclchan) <= 0) {return false;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"SELECT * FROM chantable WHERE chan_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("ChanRegistered: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return true;
	}
	if (sqlite3_bind_text (stmt,1,lclchan,strlen(lclchan),SQLITE_STATIC) != SQLITE_OK) {
		printf("ChanRegistered: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return true;
	}
	if (sqlite3_step(stmt) == SQLITE_ROW) {
		sqlite3_finalize(stmt);
		return true;
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
	return false;
}
void services_db_stop() {
	sqlite3_close(nickdb);
	sqlite3_close(chandb);
}
bool weircdServicesInit() {
	printf("%s Loading IRC services module...\n",startupprefix);
	if (services_db_init() != true) {return false;}
	return true;
}
unsigned char* services_upassword(const unsigned char* nickname) {
	unsigned char lclnick[40];
	strncpy(lclnick,nickname,39);lclnick[39] = 0;strlwr(lclnick);trimleft(lclnick);cutonfirstspace(lclnick);
	if (strlen(lclnick) <= 0) {return NULL;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"SELECT * FROM usertable WHERE useraccount_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("GNick: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_bind_text (stmt,1,lclnick,strlen(lclnick),SQLITE_STATIC) != SQLITE_OK) {
		printf("GNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_step(stmt) == SQLITE_ROW) {
		r = 0;
		k = sqlite3_column_count(stmt);
		while (r < k) {
			if (strcasecmp(sqlite3_column_name(stmt,r),"useraccount_password") == 0) {
				r1 = sqlite3_column_text(stmt,r);
				if (r1 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				r2 = malloc(strlen(r1) + 1);
				if (r2 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				strcpy(r2,r1);
				if (stmt != NULL) {sqlite3_finalize(stmt);}
				return r2;
			}
			r += 1;
		}
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
	r2 = malloc(2);
	if (r2 == NULL) {return NULL;}
	strcpy(r2,"");
	return r2;
}
unsigned char* services_chanowner(const unsigned char* channel) {
	unsigned char lclchan[40];
	strncpy(lclchan,channel,39);lclchan[39] = 0;strlwr(lclchan);trimleft(lclchan);cutonfirstspace(lclchan);
	if (strlen(lclchan) <= 0) {return NULL;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"SELECT * FROM chantable WHERE chan_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("GOwner: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_bind_text (stmt,1,lclchan,strlen(lclchan),SQLITE_STATIC) != SQLITE_OK) {
		printf("GOwner: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_step(stmt) == SQLITE_ROW) {
		r = 0;
		k = sqlite3_column_count(stmt);
		while (r < k) {
			if (strcasecmp(sqlite3_column_name(stmt,r),"chan_owner") == 0) {
				r1 = sqlite3_column_text(stmt,r);
				if (r1 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				r2 = malloc(strlen(r1) + 1);
				if (r2 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				strcpy(r2,r1);
				if (stmt != NULL) {sqlite3_finalize(stmt);}
				return r2;
			}
			r += 1;
		}
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
	r2 = malloc(2);
	if (r2 == NULL) {return NULL;}
	strcpy(r2,"");
	return r2;
}
unsigned char* services_chanorigname(const unsigned char* channel) {
	unsigned char lclchan[40];
	strncpy(lclchan,channel,39);lclchan[39] = 0;strlwr(lclchan);trimleft(lclchan);cutonfirstspace(lclchan);
	if (strlen(lclchan) <= 0) {return NULL;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"SELECT * FROM chantable WHERE chan_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("GOwner: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_bind_text (stmt,1,lclchan,strlen(lclchan),SQLITE_STATIC) != SQLITE_OK) {
		printf("GOwner: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_step(stmt) == SQLITE_ROW) {
		r = 0;
		k = sqlite3_column_count(stmt);
		while (r < k) {
			if (strcasecmp(sqlite3_column_name(stmt,r),"chan_origname") == 0) {
				r1 = sqlite3_column_text(stmt,r);
				if (r1 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				r2 = malloc(strlen(r1) + 1);
				if (r2 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				strcpy(r2,r1);
				if (stmt != NULL) {sqlite3_finalize(stmt);}
				return r2;
			}
			r += 1;
		}
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
	r2 = malloc(2);
	if (r2 == NULL) {return NULL;}
	strcpy(r2,"");
	return r2;
}
void services_setchantopic(const unsigned char* channel, const unsigned char* topic) {
	unsigned char lclchan[40];
	strncpy(lclchan,channel,39);lclchan[39] = 0;strlwr(lclchan);trimleft(lclchan);cutonfirstspace(lclchan);
	if (strlen(lclchan) <= 0) {return;}
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"UPDATE chantable SET chan_topic=? WHERE chan_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("STopic: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return;
	}
	if (sqlite3_bind_text (stmt,1,topic,strlen(topic),SQLITE_STATIC) != SQLITE_OK) {
		printf("STopic: Could not bind string. (1)\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return;
	}
	if (sqlite3_bind_text (stmt,2,lclchan,strlen(lclchan),SQLITE_STATIC) != SQLITE_OK) {
		printf("STopic: Could not bind string. (2)\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return;
	}
	int result = sqlite3_step(stmt);
	if (result != SQLITE_OK && result != SQLITE_DONE) {
		printf("STopic: Could not save topic for %s.\n",channel);
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return;
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
}
unsigned char* services_chantopic(const unsigned char* channel) {
	unsigned char lclchan[40];
	strncpy(lclchan,channel,39);lclchan[39] = 0;strlwr(lclchan);trimleft(lclchan);cutonfirstspace(lclchan);
	if (strlen(lclchan) <= 0) {return NULL;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"SELECT * FROM chantable WHERE chan_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("GOwner: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_bind_text (stmt,1,lclchan,strlen(lclchan),SQLITE_STATIC) != SQLITE_OK) {
		printf("GOwner: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_step(stmt) == SQLITE_ROW) {
		r = 0;
		k = sqlite3_column_count(stmt);
		while (r < k) {
			if (strcasecmp(sqlite3_column_name(stmt,r),"chan_topic") == 0) {
				r1 = sqlite3_column_text(stmt,r);
				if (r1 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				r2 = malloc(strlen(r1) + 1);
				if (r2 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				strcpy(r2,r1);
				if (stmt != NULL) {sqlite3_finalize(stmt);}
				return r2;
			}
			r += 1;
		}
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
	r2 = malloc(2);
	if (r2 == NULL) {return NULL;}
	strcpy(r2,"");
	return r2;
}
unsigned char* services_getemail(const unsigned char* nickname) {
	unsigned char lclnick[40];
	strncpy(lclnick,nickname,39);lclnick[39] = 0;strlwr(lclnick);trimleft(lclnick);cutonfirstspace(lclnick);
	if (strlen(lclnick) <= 0) {return NULL;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"SELECT * FROM usertable WHERE useraccount_name=?",-1,&stmt,0) != SQLITE_OK) {
		printf("GNick: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_bind_text (stmt,1,lclnick,strlen(lclnick),SQLITE_STATIC) != SQLITE_OK) {
		printf("GNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return NULL;
	}
	if (sqlite3_step(stmt) == SQLITE_ROW) {
		r = 0;
		k = sqlite3_column_count(stmt);
		while (r < k) {
			if (strcasecmp(sqlite3_column_name(stmt,r),"useraccount_email") == 0) {
				r1 = sqlite3_column_text(stmt,r);
				if (r1 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				r2 = malloc(strlen(r1) + 1);
				if (r2 == NULL) {if (stmt != NULL) {sqlite3_finalize(stmt);}return NULL;}
				strcpy(r2,r1);
				if (stmt != NULL) {sqlite3_finalize(stmt);}
				return r2;
			}
			r += 1;
		}
	}
	if (stmt != NULL) {sqlite3_finalize(stmt);}
	r2 = malloc(2);
	if (r2 == NULL) {return NULL;}
	strcpy(r2,"");
	return r2;
}
bool services_registernick(const unsigned char* nickname, const unsigned char* pw, const unsigned char* mail) {
	unsigned char lclnick[40];
	strncpy(lclnick,nickname,39);lclnick[39] = 0;strlwr(lclnick);trimleft(lclnick);cutonfirstspace(lclnick);
	if (strlen(lclnick) <= 0) {return false;}
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"INSERT INTO usertable VALUES(?,?,?,?,?)",-1,&stmt,0) != SQLITE_OK) {
		printf("RNick: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,1,lclnick,strlen(lclnick),SQLITE_STATIC) != SQLITE_OK) {
		printf("RNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,2,pw,strlen(pw),SQLITE_STATIC) != SQLITE_OK) {
		printf("RNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,3,mail,strlen(mail),SQLITE_STATIC) != SQLITE_OK) {
		printf("RNick: Could not bind string.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_int (stmt,4,time(NULL)) != SQLITE_OK) {
		printf("RNick: Could not bind int.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	int result = sqlite3_step(stmt);
	if (result != SQLITE_OK && result != SQLITE_DONE) {
		sqlite3_finalize(stmt);
		printf("RNick: DATABASE ERROR! %d\n",result);
		return false;
	}
	sqlite3_finalize(stmt);
	return true;
}
bool services_registerchan(int chanid, int uid) {
	unsigned char lclchan[40];
	strncpy(lclchan,chans[chanid]->name,39);lclchan[39] = 0;trimleft(lclchan);cutonfirstspace(lclchan);
	unsigned char lclchan2[40];strcpy(lclchan2,lclchan);strlwr(lclchan);
	if (strlen(lclchan) <= 0) {return false;}
	unsigned char lclnick[50];
	strncpy(lclnick,userpointers[uid]->accountname,49);strlwr(lclnick);trimleft(lclnick);cutonfirstspace(lclnick);
	lclnick[49] = 0;
	const unsigned char* r1 = NULL;unsigned char* r2 = NULL;int k = 0;
	int r = 0;
	sqlite3_stmt *stmt = NULL;
	if (sqlite3_prepare_v2(nickdb,"INSERT INTO chantable VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?)",-1,&stmt,0) != SQLITE_OK) {
		printf("RChan: Could not prepare statement.\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,1,lclchan,strlen(lclchan),SQLITE_STATIC) != SQLITE_OK) {
		printf("RChan: Could not bind string (1).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,2,lclchan2,strlen(lclchan2),SQLITE_STATIC) != SQLITE_OK) {//original chan name (not lowercase!)
		printf("RChan: Could not bind string (2).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,3,lclnick,strlen(lclnick),SQLITE_STATIC) != SQLITE_OK) {//chanowner
		printf("RChan: Could not bind string (3).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text (stmt,4,chans[chanid]->topic,strlen(chans[chanid]->topic),SQLITE_STATIC) != SQLITE_OK) {
		printf("RChan: Could not bind string (4).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text(stmt,5,GetChannelModes(chanid,false),strlen(GetChannelModes(chanid,false)),SQLITE_STATIC) != SQLITE_OK) {
		printf("RChan: Could not bind string (5).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_int (stmt,6,time(NULL)) != SQLITE_OK) {//registertime
		printf("RChan: Could not bind int (6).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text(stmt,7,"",0,SQLITE_STATIC) != SQLITE_OK) {//welcomemsg
		printf("RChan: Could not bind string (7).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text(stmt,8,"",0,SQLITE_STATIC) != SQLITE_OK) {//oplvl3list
		printf("RChan: Could not bind string (8).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text(stmt,9,"",0,SQLITE_STATIC) != SQLITE_OK) {//oplvl2list
		printf("RChan: Could not bind string (9).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text(stmt,10,"",0,SQLITE_STATIC) != SQLITE_OK) {//oplvl1list
		printf("RChan: Could not bind string (10).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text(stmt,11,"",0,SQLITE_STATIC) != SQLITE_OK) {//halfoplist
		printf("RChan: Could not bind string (11).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text(stmt,12,"",0,SQLITE_STATIC) != SQLITE_OK) {//voicelist
		printf("RChan: Could not bind int (12).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	if (sqlite3_bind_text(stmt,13,"",0,SQLITE_STATIC) != SQLITE_OK) {//autovoice activated
		printf("RChan: Could not bind int (13).\n");
		if (stmt != NULL) {sqlite3_finalize(stmt);}
		return false;
	}
	int result = sqlite3_step(stmt);
	if (result != SQLITE_OK && result != SQLITE_DONE) {
		sqlite3_finalize(stmt);
		printf("RChan: DATABASE ERROR! %d\n",result);
		return false;
	}
	unsigned char tell[500];
	chans[chanid]->mode_registered = true;
	snprintf(&tell[0],499,":ChanServ!services@%s JOIN %s",cuo.serviceshost,chans[chanid]->name);
	tell[499] = 0;
	tellallusersinchan(tell,chanid);
	snprintf(&tell[0],499,":ChanServ!services@%s MODE %s +r",cuo.serviceshost,chans[chanid]->name);
	tell[499] = 0;
	tellallusersinchan(tell,chanid);
	snprintf(&tell[0],499,":%s MODE %s +o ChanServ",cuo.svd,chans[chanid]->name);
	tell[499] = 0;
	tellallusersinchan(tell,chanid);
	printf("RChan: %s now registered!\n",chans[chanid]->name);
	sqlite3_finalize(stmt);
	return true;
}
bool services_userregistered(const unsigned char* nickname) {
	unsigned char* r;
	unsigned char lclnick[40];
	strncpy(lclnick,nickname,39);lclnick[39] = 0;strlwr(lclnick);trimleft(lclnick);
	r = services_upassword(lclnick);
	if (r == NULL) {return true;}//an error occured, block the nickname until prob is solved
	if (strcasecmp(r,"") == 0) {free(r);return false;}else{free(r);return true;}
}
void services_say(const unsigned char* service,const unsigned char* stuff,int uid) {
	unsigned char response[501];
	snprintf(&response[0],499,":%s!services@%s NOTICE %s :%s\n",service,cuo.serviceshost,un(uid),stuff);
	response[499] = 0;vsnd(response,uid);
}

void hostchange(int id,const unsigned char* tghost) {
	unsigned char response[501];
	snprintf(&response[0],499,":%s!%s@%s QUIT :Host has changed",un(id),userpointers[id]->suserid,userpointers[id]->host);
	response[499] = 0;
	tellaffectedusers(response,id);
	strcpy(userpointers[id]->host,tghost);
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANSPERUSER) {
		if (userpointers[id]->chan[r] != NULL) {
			snprintf(&response[0],499,":%s!%s@%s JOIN %s",un(id),userpointers[id]->suserid,userpointers[id]->host,chans[userpointers[id]->chan[r]->chanid]->name);
			response[499] = 0;
			tellallusersinchan_exclude(response,userpointers[id]->chan[r]->chanid,id);
		}
		r++;
	}
}

void services_nickserv(int uid,const unsigned char* cmd, unsigned char* params) {
	unsigned char response[501];
	unsigned char willpw[50];
	int r,k;
	if (strcasecmp(cmd,"help") == 0) {
		trimleft(params);
		cutonfirstspace(params);
		if (strcasecmp(params,"") == 0) {
			snprintf(&response[0],499,"%c- NickServ help -%c",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","  You can use NickServ to register a nick,",uid);
			services_say("NickServ","   this prevents others from using it and makes",uid);
			services_say("NickServ","   sure that only you can use it and others never",uid);
			services_say("NickServ","   have to bother if it's you or someone else",uid);
			services_say("NickServ","   abusing your nick to pretend to be you.",uid);
			services_say("NickServ"," ",uid);
			snprintf(&response[0],499,"  Type %c/msg NickServ help commands%c to get a list",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","   of all available commands.",uid);
			snprintf(&response[0],499,"  Type %c/msg NickServ help register%c to get some",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","   information on how to register your nickname",uid);
			services_say("NickServ","   to protect from others.",uid);
			services_say("NickServ","  If this doesn't help you and you still have",uid);
			snprintf(&response[0],499,"   trouble using NickServ, use %c/join %s%c",2,cuo.helpchan,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","   to get help.",uid);
			return;
		}
		if (strcasecmp(params,"commands") == 0) {
			snprintf(&response[0],499,"%c- NickServ help - %cCommands%c -%c",2,34,34,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","  Here is a list of all available nickserv commands",uid);
			snprintf(&response[0],499,"   (type %c/msg nickserv help <command>%c to get",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","    more information on one of those commands):",uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","    HELP",uid);
#ifndef SERVICES_ENFORCEPROTECT
			services_say("NickServ","    IDENTIFY",uid);
#endif
			services_say("NickServ","    REGISTER",uid);
			services_say("NickServ","    UNREGISTER",uid);
			services_say("NickServ","    INFO",uid);
			if (userpointers[uid]->ircop == true) {
				snprintf(&response[0],499,"%cIRCop commands:%c DROP, STATS, SETPASS",2,2);
				response[499] = 0;
				services_say("NickServ",response,uid);
			}
			return;
		}
		if (strcasecmp(params,"register") == 0) {
			snprintf(&response[0],499,"%c- NickServ help - %cRegister%c -%c",2,34,34,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ"," ",uid);
			services_say("NickServ","  You can register your current nickname using",uid);
			snprintf(&response[0],499,"   the command %c/msg nickserv register <password> <e-mail>%c!",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			snprintf(&response[0],499,"   (Please replace %c<password>%c and %c<e-mail>%c with proper",2,2,2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","    values!)",uid);
			services_say("NickServ"," ",uid);
#ifdef SERVICES_ENFORCEPROTECT
			services_say("NickServ","  This will protect this nick and only who enter your",uid);
			services_say("NickServ","   secret password as server password on connect will",uid);
			services_say("NickServ","   be able to use your nickname.",uid);
#endif
#ifndef SERVICES_ENFORCEPROTECT
			if (SERVICES_LOGINTIMEOUT > 0) {
				services_say("NickServ","  This will protect this nick and everyone who takes",uid);
				snprintf(&response[0],499,"   your nickname and doesn't identify in %d seconds",SERVICES_LOGINTIMEOUT);
				response[499] = 0;
				services_say("NickServ",response,uid);
				services_say("NickServ","   will get force-renamed so nobody can fake your",uid);
				services_say("NickServ","   identity.",uid);
			}else{
				services_say("NickServ","  This will show others in your whois when you are",uid);
				services_say("NickServ","   logged in that you are actually the user they",uid);
				services_say("NickServ","   think you are and not somebody faking you.",uid);
			}
#endif
			services_say("NickServ","  If you ever forget your secret password yourself,",uid);
			snprintf(&response[0],499,"   go to %s and ask for a new password being sent to",cuo.helpchan);
			response[499] = 0;
			services_say("NickServ",response,uid);
			services_say("NickServ","   the e-mail address you entered.",uid);
			services_say("NickServ","  Only server admins will be able to see the e-mail",uid);
			services_say("NickServ","   address you entered.",uid);
			return;
		}
		snprintf(&response[0],499,"No help available for %s",params);
		response[499] = 0;
		services_say("NickServ",response,uid);
		return;
	}
#ifndef SERVICES_ENFORCEPROTECT
	if (strcasecmp(cmd,"identify") == 0) {
		trimleft(params);cutonfirstspace(params);
		if (strlen(params) <= 0) {
			snprintf(&response[0],499,"Type %c/msg NickServ identify <password>%c to login.",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			return;
		}
		if (userpointers[uid]->accountname != NULL) {
			if (strcasecmp(userpointers[uid]->accountname,"") != 0) {
				snprintf(&response[0],499,"You are already identified as %c%s%c.",2,userpointers[uid]->accountname,2);
				response[499] = 0;
				services_say("NickServ",response,uid);
				return;
			}
		}
		if (services_userregistered(userpointers[uid]->nickname) == false) {
			snprintf(&response[0],499,"Your nickname %c%s%c is not registered.",2,un(uid),2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			return;
		}
		int ipid = getIpID(userpointers[uid]->ip);
		if (ipid < 0) {
			services_say("NickServ","NickServ is currently experiencing a problem.",uid);
			return;
		}
		
		unsigned char* p = services_upassword(userpointers[uid]->nickname);
		if (p == NULL) {
			services_say("NickServ","The server is currently experiencing a database problem.",uid);
			return;
		}else{
			if (strcasecmp(p,"") != 0) {
				if (strcasecmp(params,p) != 0) {
					ips[ipid]->lastnickfail3 = ips[ipid]->lastnickfail2;
					ips[ipid]->lastnickfail2 = ips[ipid]->lastnickfail1;
					ips[ipid]->lastnickfail1 = time(NULL);
					if (ips[ipid]->lastnickfail1 + 60 > time(NULL) && ips[ipid]->lastnickfail2 + 120 > time(NULL) && ips[ipid]->lastnickfail3 + 120 > time(NULL)) {
						vsnd("ERROR :Closing Link: Too many failed login attempts",uid);
						strcpy(response,"Killed by NickServ (Too many failed login attempts)");
						ips[ipid]->lastnickfail1 = 0;ips[ipid]->lastnickfail2 = 0;ips[ipid]->lastnickfail3 = 0;
						userpointers[uid]->quitreason = malloc(strlen(response)+1);
						if (userpointers[uid]->quitreason != NULL) {
							strcpy(userpointers[uid]->quitreason,response);
						}
						userQuit(uid,USERQUIT_ERROR);
						return;
					}
					services_say("NickServ","The password is wrong.",uid);
					free(p);
					return;
				}else{
					//set registered flag
					userpointers[uid]->accountname = malloc(strlen(userpointers[uid]->nickname) + 1);
					if (userpointers[uid]->accountname == NULL) {
						services_say("NickServ","The server is currently experiencing a memory allocation problem.",uid);
						free(p);
						return;
					}
					strcpy(userpointers[uid]->accountname,userpointers[uid]->nickname);
					services_say("NickServ","*** You are now logged in (NickServ)",uid);
					userpointers[uid]->needstimeout = 0;
					const unsigned char* e = generate_vhost_user(userpointers[uid]->accountname,userpointers[uid]->ip);
					if (e != NULL) {
						hostchange(uid,e);
					}
					free(p);
					return;
				}
			}
		}
	}
#endif
	if (strcasecmp(cmd,"info") == 0) {
		trimleft(params);cutonfirstspace(params);
		if (strlen(params) <= 0) {
			snprintf(&response[0],499,"Type %c/msg NickServ info <nickname>%c to get information about a specific nickname.",2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			return;
		}
		if (services_userregistered(params) == true) {
			snprintf(&response[0],499,"Username %c%s%c is %cregistered%c.",34,params,34,2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			if (userpointers[uid]->ircop == true) {
				unsigned char* j = NULL;
				j = services_getemail(params);
				if (j != NULL) {
					snprintf(&response[0],499,"The %ce-mail%c address of %c%s%c is %s",2,2,34,params,34,j);
					response[499] = 0;
					services_say("NickServ",response,uid);
					free(j);
				}else{
					snprintf(&response[0],499,"The %ce-mail%c address of %c%s%c is >>null<<",2,2,34,params,34);
					response[499] = 0;
					services_say("NickServ",response,uid);
				}
				return;
			}else{
				userpointers[uid]->floodprotect.floodpoints += 2;
			}
			return;
		}else{
			snprintf(&response[0],499,"Username %c%s%c is %cfree%c.",34,params,34,2,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			return;
		}
	}
	if (strcasecmp(cmd,"register") == 0) {
		if (userpointers[uid]->accountname != NULL) {
			snprintf(&response[0],499,"You are already logged in as %c%s%c.",2,userpointers[uid]->accountname,2);
			response[499] = 0;
			services_say("NickServ",response,uid);
			return;
		}else{
			if (userpointers[uid]->lastnickchange + cuo.nickwaittime > time(NULL)) {
				snprintf(&response[0],499,"Please wait %c%d seconds%c before you attempt to register your nickname (register flood protection)",2,(userpointers[uid]->lastnickchange + cuo.nickwaittime) - time(NULL),2);
				response[499] = 0;
				services_say("NickServ",response,uid);
				return;
			}else{
				if (strcasecmp(userpointers[uid]->nickname,"guest") == 0 || strstw(userpointers[uid]->nickname,"guest") == true) {
					services_say("NickServ","You cannot register this nickname.",uid);
				}else{
					if (services_userregistered(userpointers[uid]->nickname) == true) {
						services_say("NickServ","This nickname has already been registered.",uid);
						return;
					}
					trimleft(params);
					if (strlen(params) <= 2 || charpos(params,32) <= 0) {
						snprintf(&response[0],499,"Register: There are some parameters missing! Use %c/msg nickserv help register%c to check the correct syntax of this command",2,2);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}
					strncpy(willpw,params,49);willpw[49] = 0;
					cutonfirstspace(willpw);
					cut(params,charpos(params,32) + 1);
					cutonfirstspace(params);
					if (strlen(params) < 1 || strlen(willpw) < 1) {
						snprintf(&response[0],499,"Register: There are some parameters missing! Use %c/msg nickserv help register%c to check the correct syntax of this command",2,2);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}
					if (charpos(params,'@') <= 0) {
						snprintf(&response[0],499,"Register: The second parameter should be a %cvalid%c e-mail address - without a working e-mail address, your %caccount will be lost%c if you ever forget your password.",2,2,2,2);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}
					if (strlen(willpw) < 8 || strcasecmp(willpw,"password") == 0 || strcasecmp(willpw,"<password>") == 0) {
						snprintf(&response[0],499,"It is important that your password is very random and not too short (at least %c8 chars long%c). In case you can't remember it one day, you can ask for a new password in %s which will be send to your e-mail address, so don't fear to use a complicated password! %cThis password is too weak.%c",2,2,cuo.helpchan,2,2);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}
					if (services_registernick(userpointers[uid]->nickname,willpw,params) == false) {
						snprintf(&response[0],499,"The %cregistration failed%c (Technical problem: database reports error). Please join %s for help.",2,2,cuo.helpchan);
						response[499] = 0;
						services_say("NickServ",response,uid);
						return;
					}else{
						userpointers[uid]->accountname = malloc(strlen(userpointers[uid]->nickname) + 1);
						if (userpointers[uid]->accountname == NULL) {
							snprintf(&response[0],499,"The %cregistration failed%c (Technical problem: database reports error). Please join %s for help.",2,2,cuo.helpchan);
							response[499] = 0;
							services_say("NickServ",response,uid);
							return;
						}else{
							strcpy(userpointers[uid]->accountname,userpointers[uid]->nickname);
							strlwr(userpointers[uid]->accountname);
							snprintf(&response[0],499,"Your nickname %c%s%c is now registered.",2,userpointers[uid]->nickname,2);
							response[499] = 0;
							services_say("NickServ",response,uid);
							const unsigned char* p = generate_vhost_user(userpointers[uid]->accountname,userpointers[uid]->ip);
							if (p != NULL) {
								hostchange(uid,p);
							}
							return;
						}
					}
				}
			}
		}
	}
	snprintf(&response[0],499,"Unknown command. Type %c/NickServ help%c for help.",2,2);
	response[499] = 0;
	services_say("NickServ",response,uid);
}
void services_chanserv(int uid,const unsigned char* cmd, unsigned char* params) {
	unsigned char response[501];
	if (strcasecmp(cmd,"help") == 0) {
		trimleft(params);
		cutonfirstspace(params);
		if (strcasecmp(params,"") == 0) {
			snprintf(&response[0],499,"%c- ChanServ help -%c",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ"," ",uid);
			services_say("ChanServ","  You can use ChanServ to register a channel.",uid);
			services_say("ChanServ","   ChanServ will always give you op status back",uid);
			services_say("ChanServ","   and prevent everyone else from getting channel",uid);
			services_say("ChanServ","   operator status on you registered channel.",uid);
			services_say("ChanServ","  You need to register your nickname for being",uid);
			snprintf(&response[0],499,"   able to register a channel (type %cmsg nickserv",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			snprintf(&response[0],499,"   help%c to get more information on this).",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ"," ",uid);
			snprintf(&response[0],499,"  Type %c/msg ChanServ help commands%c to get a list",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","   of all available commands.",uid);
			snprintf(&response[0],499,"  Type %c/msg ChanServ help register%c to get some",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","   information on how to register a channel.",uid);
			services_say("ChanServ","  If this doesn't help you and you still have",uid);
			snprintf(&response[0],499,"   trouble using ChanServ, use %c/join %s%c",2,cuo.helpchan,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","   to get help.",uid);
			return;
		}
		if (strcasecmp(params,"commands") == 0) {
			snprintf(&response[0],499,"%c- ChanServ help - %cCommand%c -%c",2,34,34,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ"," ",uid);
			services_say("ChanServ","  Here is a list of all available nickserv commands",uid);
			snprintf(&response[0],499,"   (type %c/msg nickserv help <command>%c to get",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","    more information on one of those commands):",uid);
			services_say("ChanServ"," ",uid);
			services_say("ChanServ","    HELP",uid);
			services_say("ChanServ","    REGISTER",uid);
			services_say("ChanServ","    UNREGISTER",uid);
			services_say("ChanServ","    ACCESS",uid);
			services_say("ChanServ","    INFO",uid);
			if (userpointers[uid]->ircop == true) {
				snprintf(&response[0],499,"%cIRCop commands:%c DROP",2,2);
				response[499] = 0;
				services_say("ChanServ",response,uid);
			}
			return;
		}
		if (strcasecmp(params,"levels") == 0) {
			snprintf(&response[0],499,"%c- ChanServ help - %cLevels%c -%c",2,34,34,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ"," ",uid);
			services_say("ChanServ","  The following access levels are available:",uid);
			snprintf(&response[0],499,"   %cop3%c - Channel op level 3",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","         chanop, protected, access list",uid);
			snprintf(&response[0],499,"   %cop2%c - Channel op level 2",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","         chanop, protected",uid);
			snprintf(&response[0],499,"   %cop1%c - Channel op level 1",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","         chanop status",uid);
			snprintf(&response[0],499,"   %chalfop%c - Half-Operator",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","         halfop status",uid);
			snprintf(&response[0],499,"   %cvoice%c - Voice",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","         voiced",uid);
			services_say("ChanServ"," ",uid);
			snprintf(&response[0],499,"  Type %c/msg chanserv access <channel> add <user>%c",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			snprintf(&response[0],499,"   %c<level>%c to add the given user to the access",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","   list with the specified level.",uid);
			return;
		}
		if (strcasecmp(params,"access") == 0) {
			snprintf(&response[0],499,"%c- ChanServ help - %cAccess%c -%c",2,34,34,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ"," ",uid);
			services_say("ChanServ","  Access allows you to put registered users",uid);
			services_say("ChanServ","   onto an access list to get them automatically",uid);
			services_say("ChanServ","   opped by ChanServ on join when they are logged",uid);
			services_say("ChanServ","   in to their NickServ account.",uid);
			services_say("ChanServ"," ",uid);
			snprintf(&response[0],499,"  Use %c/msg chanserv access <channel> list%c to",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","   get the contents of the current access list.",uid);
			services_say("ChanServ"," ",uid);
			snprintf(&response[0],499,"  Type %c/msg chanserv help levels%c to",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","   get a list of the different access levels",uid);
			services_say("ChanServ","   possible and a short explanation what they",uid);
			services_say("ChanServ","   do.",uid);
			services_say("ChanServ"," ",uid);
			snprintf(&response[0],499,"  Type %c/msg chanserv access <channel> add <user>%c",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			snprintf(&response[0],499,"   %c<level>%c to add the given user to the access",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ","   list with the specified level. If you want to",uid);
			services_say("ChanServ","   remove a user from the list, use the command",uid);
			snprintf(&response[0],499,"   %c/msg chanserv access <channel> remove <user>%c",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			return;
		}
		if (strcasecmp(params,"register") == 0) {
			snprintf(&response[0],499,"%c- ChanServ help - %cRegister%c -%c",2,34,34,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			services_say("ChanServ"," ",uid);
			services_say("ChanServ","  You can register a channel where you have",uid);
			services_say("ChanServ","   currently channel operator status using the",uid);
			snprintf(&response[0],499,"   command %c/msg chanserv register <channel>%c!",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			return;
		}
		snprintf(&response[0],499,"No help available for %s",params);
		response[499] = 0;
		services_say("ChanServ",response,uid);
		return;
	}
	if (strcasecmp(cmd,"access") == 0) {
		trimleft(params);
		unsigned char channame[500];
		strncpy(channame,params,499);
		channame[499] = 0;
		if (charpos(channame,' ') > 0) {channame[charpos(channame,' ')] = 0;}
		if (charpos(params,' ') > 0) {
			cut(params,charpos(params,' ')+1);
		}else{
			strcpy(params,"");
		}
		trimleft(params);trimright(params);strlwr(channame);
		if (strlen(params) <= 0) {
			snprintf(&response[0],499,"Parameter missing. Type %c/msg ChanServ help access%c to get help on using this command.",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			return;
		}
		unsigned char subcmd[500];
		if (charpos(params,' ') > 0) {
			strcpy(subcmd,params);
			subcmd[charpos(subcmd,' ')] = 0;
			cut(params,charpos(params,' ')+1);
		}else{
			strcpy(subcmd,params);
			strcpy(params,"");
		}
		if (chanregistered(channame) == false) {
			snprintf(&response[0],499,"Channel %s is %cnot registered%c!",channame,2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			return;
		}
		if (strcasecmp(subcmd,"list") == 0) {
			snprintf(&response[0],499,"%cAccess list%c of %s:",2,2,channame);
			response[499] = 0;//spaces((COMPILEOPTION_MAXNICKLEN + 1) - nicklen);
			services_say("ChanServ",response,uid);
			return;
		}
		snprintf(&response[0],499,"Parameter missing. Type %c/msg ChanServ help access%c to get help on using this command.",2,2);
		response[499] = 0;
		services_say("ChanServ",response,uid);
		return;
	}
	if (strcasecmp(cmd,"info") == 0) {
		trimleft(params);cutonfirstspace(params);
		if (strlen(params) <= 0) {
			snprintf(&response[0],499,"Type %c/msg ChanServ info <channel>%c to get information about a specific channel.",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			return;
		}
		if (chanregistered(params) == true) {
			snprintf(&response[0],499,"Channel %c%s%c is %cregistered%c.",34,params,34,2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			unsigned char* j = NULL;
			j = services_chanowner(params);
			if (j != NULL) {
				snprintf(&response[0],499,"The %cowner%c of %s is %s",2,2,params,j);
				response[499] = 0;
				services_say("ChanServ",response,uid);
				free(j);
			}else{
				snprintf(&response[0],499,"The %cowner%c of %s is >>null<<",2,2,params);
				response[499] = 0;
				services_say("ChanServ",response,uid);
			}
			return;
		}else{
			snprintf(&response[0],499,"Channel %c%s%c is %cunregistered%c.",34,params,34,2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			return;
		}
	}
	if (strcasecmp(cmd,"register") == 0) {
		if (userpointers[uid]->accountname == NULL) {
			snprintf(&response[0],499,"Your nickname is not registered! Read %cmsg chanserv help%c how to solve this problem.",2,2);
			response[499] = 0;
			services_say("ChanServ",response,uid);
			return;
		}else{
			trimleft(params);
			if (strlen(params) <= 1) {
				snprintf(&response[0],499,"Register: There are some parameters missing! Use %c/msg chanserv help register%c to check the correct syntax of this command",2,2);
				response[499] = 0;
				services_say("ChanServ",response,uid);
				return;
			}
			int r = getChanID(params);
			if (r < 0) {
				snprintf(&response[0],499,"Register: Channel %s does not exist!",params);
				response[499] = 0;
				services_say("ChanServ",response,uid);
				return;
			}
			if (isuserinchan(uid,r) == false) {
				services_say("ChanServ","Register: You are not on that channel!",uid);
				return;
			}
			if (isoponchan(uid,r) == false) {
				snprintf(&response[0],499,"Register: You have no channel operator status on %s!",chans[r]->name);
				response[499] = 0;
				services_say("ChanServ",response,uid);
				return;
			}
			if (chanregistered(params) == true) {
				services_say("ChanServ","Register: This channel is already registered!",uid);
				return;
			}
			if (services_registerchan(r,uid) == false) {
				snprintf(&response[0],499,"The %cregistration failed%c (Technical problem: database reports error). Please join %s for help.",2,2,cuo.helpchan);
				response[499] = 0;
				services_say("ChanServ",response,uid);
				return;
			}else{
				int j = 0;
				while (j < COMPILEOPTION_MAXCHANSPERUSER) {
					if (userpointers[uid]->chan[j] != NULL) {
						if (userpointers[uid]->chan[j]->chanid == r) {
							userpointers[uid]->chan[j]->iamprotected = true;
						}
					}
					j++;
				}
				snprintf(&response[0],499,"The channel %c%s%c is now registered.",2,chans[r]->name,2);
				response[499] = 0;
				services_say("ChanServ",response,uid);
				return;
			}
		}
		return;
	}
	snprintf(&response[0],499,"Unknown command. Type %c/ChanServ help%c for help.",2,2);
	response[499] = 0;
	services_say("ChanServ",response,uid);
}
void services_gateway_privmsg(int uid,const unsigned char* vstuff,const unsigned char* targetserv) {
	userpointers[uid]->floodprotect.floodpoints += 2;
	unsigned char stuff[500];
	strncpy(stuff,vstuff,499);
	stuff[499] = 0;
	trimleft(stuff);
	unsigned char cmd[40];
	strncpy(cmd,stuff,39);cmd[39] = 0;cutonfirstspace(cmd);
	unsigned char params[520];
	strncpy(params,stuff,519);params[519] = 0;if (charpos(params,32) >= 0) {cut(params,charpos(params,32)+1);}else{strcpy(params,"");}
	if (strcasecmp(targetserv,"nickserv") == 0) {
		services_nickserv(uid,cmd,params);
		return;
	}
	if (strcasecmp(targetserv,"chanserv") == 0) {
		services_chanserv(uid,cmd,params);
		return;
	}
}
void services_gateway_notice(int uid,const unsigned char* vstuff,const unsigned char* targetserv) {
	
}

